//  : WmAv ("")
// : 0.3
//   : 24.08.2010
// :  
// : wmlab@hotmail.com
//
//     "" (http://forum.mql4.com/ru/30433/)
//     6.2 (http://forum.mql4.com/ru/34565/)

// 0.2 (23.08.2010) -   CloseByAllOrders
// 0.3 (24.08.2010) -   MaxProfit,   LoadHistory

#property copyright "Copyright  2010, Murad Ismayilov"
#property link      "http://www.wmlab.org/"

#include <stdlib.mqh>
#include <stderror.mqh>

//
//   ()
//

extern double Lot = 0.1; //  
extern int DistancePips = 25; //         
extern double MaxProfit = 5.0; // ,      
extern double KMartin = 2.0; // .    
extern int TrailStepPips = 5; //    

//
//  
//

bool IsExpertFailed = false;
bool IsExpertStopped = false;
int MagicNumber = 170800;
int NumberOfTry = 5;
int SlipPips = 3;
bool UseSound = true;
color ColorBuy = Blue;
color ColorSell = Red;

//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+

int init()
{
   IsExpertStopped = false;
   if (!IsTradeAllowed())
   {
      Comment("   ");
      IsExpertStopped = true;
      return (0);
   }
      
   if (!IsTesting())
   {
      if (IsExpertEnabled())
      {
         Comment("    ");
      }
      else 
      {
         Comment("  \"  \"");
      }
   }
   
   //     
   
   if ((Digits == 3) || (Digits == 5))
   {
      SlipPips = SlipPips * 10;
      DistancePips = DistancePips * 10;
      TrailStepPips = TrailStepPips * 10;
   }   
   
   return (0);
}
  
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+

int deinit()
{
   if (!IsTesting())
   {   
      Comment("");
   }

   return (0);
}
  
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
  
int start() 
{
   if (IsExpertStopped)
   {
      Comment("   !");
      return (0);
   }
   
   if (IsExpertFailed)
   {
      Comment(" !  .");
      return (0);
   }
   
   int NumBuy = 0;
   int NumSell = 0;
   int NumBuyStop = 0;
   int NumSellStop = 0;
   double Profit = 0.0;
   double LotBuy = 0.0;
   double LotSell = 0.0;
   double LevelBuy;
   double LevelStop;
   double LotBuyStop = 0.0;
   double LotSellStop = 0.0;

   int orderType;
   for (int orderIndex = (OrdersTotal() - 1); orderIndex >= 0; orderIndex--)
   {
      if (!OrderSelect(orderIndex, SELECT_BY_POS))
      {
         continue;
      }

      if ((OrderSymbol() != Symbol()) || (OrderMagicNumber() != MagicNumber))
      {
         continue;
      }
      
      orderType = OrderType();
      switch (orderType)
      {
         case OP_BUY:
            NumBuy++;
            Profit += OrderProfit() + OrderSwap();
            LotBuy += OrderLots();
            LevelBuy = OrderOpenPrice();
            break;
            
         case OP_SELL:
            NumSell++;
            Profit += OrderProfit() + OrderSwap();
            LotSell += OrderLots();
            LevelStop = OrderOpenPrice();
            break;
            
         case OP_BUYSTOP:
            NumBuyStop++;
            LevelBuy = OrderOpenPrice();
            LotBuyStop += OrderLots();
            break;
            
          case OP_SELLSTOP:
            NumSellStop++;
            LevelStop = OrderOpenPrice();
            LotSellStop += OrderLots();
            break;
      }
   }
   
   Comment(
      " = $", Profit, "   = $", AccountBalance(),
      "\nLotBuy = ", LotBuy, "  LotBuyStop = ", LotBuyStop,
      "\nLotSell = ", LotSell, "  LotSellStop = ", LotSellStop);
      
   if ((NumBuy + NumSell + NumBuyStop + NumSellStop) == 0)
   {
      //  
      WmOrderSend(Symbol(), OP_BUYSTOP, Lot, NormalizeDouble(Ask + (DistancePips * Point), Digits), 0, 0, "", MagicNumber);
      WmOrderSend(Symbol(), OP_SELLSTOP, Lot, NormalizeDouble(Bid - (DistancePips * Point), Digits), 0, 0, "", MagicNumber);
      return (0);
   }   

   double lots;

   //    
   if ((LotBuy > LotSell) && (LotBuy >= (LotSell + LotSellStop))) 
   {
      //  BUY   SELL
      lots = NormalizeLots((LotBuy * KMartin) - (LotSell + LotSellStop));
      WmOrderSend(Symbol(), OP_SELLSTOP, lots, LevelStop, 0, 0, "Lock", MagicNumber);
      return(0);
   }
   
   if ((LotSell > LotBuy) && (LotSell >= (LotBuy + LotBuyStop))) 
   {
      //  SELL   BUY
      lots = NormalizeLots((LotSell * KMartin) - (LotBuy + LotBuyStop));
      WmOrderSend(Symbol(), OP_BUYSTOP, lots, LevelBuy, 0, 0, "Lock", MagicNumber);
      return(0);
   }

   //  
   double newsl;
   if (((LotBuy + LotSell) <= (3 * Lot)) && (Profit >= ((MaxProfit * Lot) / 0.01)))
   {       
      for (orderIndex = (OrdersTotal() - 1); orderIndex >= 0; orderIndex--)
      {
         if (!OrderSelect(orderIndex, SELECT_BY_POS))
         {
            continue;
         }

         if ((OrderSymbol() != Symbol()) || (OrderMagicNumber() != MagicNumber))
         {
            continue;
         }
      
         orderType = OrderType();
         if (orderType == OP_BUY)
         {
            newsl = NormalizeDouble(Bid - (2.0 * DistancePips * Point), Digits);
            if (OrderStopLoss() == 0.0)
            { 
               OrderModify(OrderTicket(), OrderOpenPrice(), newsl, 0, 0, CLR_NONE);
            }  
            else
            {
               if (newsl > (OrderStopLoss() + (TrailStepPips * Point)))
               { 
                  OrderModify(OrderTicket(), OrderOpenPrice(), newsl, 0, 0, CLR_NONE);
               }
            }
         }
         else if (orderType == OP_SELL)
         {
            newsl = NormalizeDouble(Ask + (2.0 * DistancePips * Point), Digits);
            if (OrderStopLoss() == 0.0)
            { 
               OrderModify(OrderTicket(), OrderOpenPrice(), newsl, 0, 0, CLR_NONE);
            }
            else
            {
               if (newsl < (OrderStopLoss() - (TrailStepPips * Point)))
               { 
                  OrderModify(OrderTicket(), OrderOpenPrice(), newsl, 0, 0, CLR_NONE);
               }
            }          
         }
      }
   }

   if (((LotBuy + LotBuyStop) == 0.0) || ((LotSell + LotSellStop) == 0.0)) 
   {
      CloseByAllOrders(MagicNumber);
      CloseAllOrders(MagicNumber);
   }

   if ((Profit >= ((MaxProfit * Lot) / 0.01)) && ((LotSell + LotBuy) > (2.0 * Lot)))
   {
      CloseByAllOrders(MagicNumber);
      CloseAllOrders(MagicNumber);
   }
   
   return(0);
}

//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+

void CloseByAllOrders(int magic)
{
   while (true)
   {
      double hedgBuy = 0.0;
      double hedgSell = 0.0;
      int ticketBuy;
      int ticketSell;
      for (int orderIndex = 1; orderIndex <= OrdersTotal(); orderIndex++)
      {
         if (OrderSelect(orderIndex - 1, SELECT_BY_POS))
         {
            if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == magic))
            {
               int orderType = OrderType();
               if ((orderType != OP_BUY) && (orderType != OP_SELL))
               {
                  continue;
               }
               
               if (orderType == OP_BUY)
               {
                  if (OrderLots() > hedgBuy)
                  {
                     hedgBuy = OrderLots();
                     ticketBuy = OrderTicket();
                  }
               }
               else
               {
                  if (OrderLots() > hedgSell)
                  {
                     hedgSell = OrderLots();
                     ticketSell = OrderTicket();
                  }
               }
            }
         }
      }
                
      if ((hedgBuy == 0.0) || (hedgSell == 0.0))
      {
         return;
      }
      
      bool result;
      int error;
      for (int try = 1; try <= NumberOfTry; try++)
      {
         if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) 
         {
            return;
         }
         
         while (!IsTradeAllowed()) 
         {
            Sleep(5000);
         }
      
         result = OrderCloseBy(ticketBuy, ticketSell);
         if (result)
         {         
            Print ("Performed closing by tb =", ticketBuy, " ts = ", ticketSell);
            if (UseSound) 
            {
               PlaySound("expert.wav");
               break;
            }
         } 
         else
         {
            error = GetLastError();
            if (error == ERR_TRADE_CONTEXT_BUSY) 
            {
               while (IsTradeContextBusy()) 
               {
                  Sleep(1000*11);
               }
            }
            else
            {
               Print("Error(", error, ") CloseBy ", GetNameOP(OrderType()), " ", ErrorDescription(error), ", try ", try);         
               if ((error == ERR_COMMON_ERROR) || (error == ERR_ACCOUNT_DISABLED) || (error == ERR_INVALID_ACCOUNT) || (error == ERR_TRADE_DISABLED))
               {
                  IsExpertFailed = true;
                  return;
               }
               
               Sleep(1000*5);
            }            
         }
      }
   }
}

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+

double NormalizeLots(double lot)
{
   double lotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double lots = NormalizeDouble(lot / lotStep, 0) * lotStep;   
   lots = MathMax(lots, MarketInfo(Symbol(), MODE_MINLOT));
   lots = MathMin(lots, MarketInfo(Symbol(), MODE_MAXLOT));   
   return (lots);
}
  
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+

void WmOrderSend(string symbol, int cmd, double volume, double price, double stoploss, double takeprofit, string comment, int magic, datetime expiration = 0)
{
   color clr;
   datetime opentime;
   int ticket;
   int error;
  
   comment = WindowExpertName() + " " + GetNameTF(Period()) + " " + comment;
   int msl = MarketInfo(symbol, MODE_STOPLEVEL);
   clr = CLR_NONE;
   if ((cmd == OP_BUY) || (cmd == OP_BUYSTOP) || (cmd == OP_SELLLIMIT))
   {
      clr = ColorBuy;
   }
   else if ((cmd == OP_SELL) || (cmd == OP_SELLSTOP) || (cmd == OP_BUYLIMIT))
   {
      clr = ColorSell;
   }
   
   if ((expiration > 0) && (expiration < TimeCurrent())) 
   {
      expiration = 0;
   }
  
   for (int try = 1; try <= NumberOfTry; try++)
   {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped()))
      {
         break;
      }
   
      while (!IsTradeAllowed()) 
      {
         Sleep(5000);
      }
    
      RefreshRates();
      opentime = TimeCurrent();
      ticket = OrderSend(symbol, cmd, volume, price, SlipPips, stoploss, takeprofit, comment, magic, expiration, clr);
      if (ticket > 0)
      {
         if (UseSound) 
         {
            PlaySound("ok.wav"); 
            break;
         }
      } 
      else
      {
         error = GetLastError();
         if (error == ERR_TRADE_TIMEOUT)
         {
            Sleep(1000*60);
            if (ExistOrders(symbol, cmd, magic, opentime))
            {
               if (UseSound) 
               {
                  PlaySound("ok.wav"); 
                  break;
               }
            }
         }
        
         Print("Error(", error, ") set order: ", ErrorDescription(error), ", try ", try);
         continue;
      }
      
      Print("Error(", error, ") set order: ", ErrorDescription(error), ", try ", try);
      Print("Ask=", Ask, "  Bid=", Bid, "  symbol=", symbol, "  volume=", volume, "  cmd=", GetNameOP(cmd), "  price=", price, "  stoploss=", stoploss, "  takeprofit=", stoploss, "  magic=", magic);
      if ((error == ERR_COMMON_ERROR) || (error == ERR_ACCOUNT_DISABLED) || (error == ERR_INVALID_ACCOUNT) || (error == ERR_TRADE_DISABLED))
      {
         IsExpertFailed = true;
         break;
      }
      
      if ((error == ERR_SERVER_BUSY) || (ERR_INVALID_TRADE_VOLUME) || (error == ERR_MARKET_CLOSED))
      {
         Sleep(1000*300); 
         break;
      }
      
      if ((error == ERR_TOO_FREQUENT_REQUESTS) || (error == ERR_TOO_MANY_REQUESTS)) 
      {
         Sleep(1000*100);
      }
      
      if ((error == ERR_ORDER_LOCKED) || (error == ERR_LONG_POSITIONS_ONLY_ALLOWED) || (error == ERR_TRADE_TOO_MANY_ORDERS)) 
      {
         break;
      }
      
      if (error == ERR_TRADE_CONTEXT_BUSY) 
      {
         while (IsTradeContextBusy()) 
         {
            Sleep(1000*10);
         }
      }
      
      if (error == ERR_TRADE_EXPIRATION_DENIED )
      {
         expiration = 0; 
         continue;
      }
      
      if ((error != ERR_PRICE_CHANGED) && (error != ERR_REQUOTE)) 
      {
         Sleep(1000*10);
      }
   }      
}

//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+

bool ExistOrders(string symbol, int cmd, int magic, datetime opentime = 0)
{
   int orderType;
   for (int i = 0; i < OrdersTotal(); i++)
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
         orderType = OrderType();
         if ((orderType > 1) && (orderType < 6))
         {
            if (OrderSymbol() == symbol)
            {
               if (OrderMagicNumber() == magic)
               {
                  if (opentime <= OrderOpenTime()) 
                  return (true);
               }
            }
         }
      }
   }
  
   return (false);
}

//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+

string GetNameTF(int timeFrame)
{
   switch (timeFrame)
   {
      case PERIOD_M1:  return ("M1");
      case PERIOD_M5:  return ("M5");
      case PERIOD_M15: return ("M15");
      case PERIOD_M30: return ("M30");
      case PERIOD_H1:  return ("H1");
      case PERIOD_H4:  return ("H4");
      case PERIOD_D1:  return ("Daily");
      case PERIOD_W1:  return ("Weekly");
      case PERIOD_MN1: return ("Monthly");
      default:         return (DoubleToStr(timeFrame, 0));
   }
}

//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+

string GetNameOP(int cmd)
{
   switch (cmd)
   {
      case OP_BUY      : return ("Buy");
      case OP_SELL     : return ("Sell");
      case OP_BUYLIMIT : return ("Buy Limit");
      case OP_SELLLIMIT: return ("Sell Limit");
      case OP_BUYSTOP  : return ("Buy Stop");
      case OP_SELLSTOP : return ("Sell Stop");
      default          : return (DoubleToStr(cmd, 0));
   }
}

//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+

void ClosePosBySelect(double volume = 0.0)
{
   color clr;
   double price;
   bool result;
   int error;   

   if ((OrderType() == OP_BUY) || (OrderType() == OP_SELL))
   {
      for (int try = 1; try <= NumberOfTry; try++)
      {
         if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) 
         {
            break;
         }
         
         while (!IsTradeAllowed()) 
         {
            Sleep(5000);
         }
      
         RefreshRates();
         if (OrderType() == OP_BUY)
         {
            price = Bid; 
            clr = ColorBuy;
         } 
         else
         {
            price = Ask; 
            clr = ColorSell;
         }

         if (volume == 0.0)
         {
            volume = OrderLots();
         }
         
         result = OrderClose(OrderTicket(), volume, price, SlipPips, clr);
         if (result)
         {
            if (UseSound) 
            {
               PlaySound("expert.wav");
               break;
            }
         } 
         else
         {
            error = GetLastError();
            if (error == ERR_TRADE_CONTEXT_BUSY) 
            {
               while (IsTradeContextBusy()) 
               {
                  Sleep(1000*11);
               }
            }
            
           Print("Error(", error, ") Close ", GetNameOP(OrderType()), " ", ErrorDescription(error), ", try ", try);
           Print(OrderTicket(),"  Ask=", Ask,"  Bid=", Bid, "  price=", price);
           Print("symbol=", OrderSymbol(),"  volume=", OrderLots(),"  stoploss=", OrderStopLoss(), "  takeprofit=", OrderTakeProfit(),"  magic=", OrderMagicNumber());
           Sleep(1000*5);
         }
      }
   } 
   else 
   {
      Print("Incorrect Close ", GetNameOP(OrderType()));
   }
}

//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+

void CloseAllOrders(int magic)
{
   for (int orderIndex = (OrdersTotal() - 1); orderIndex >= 0; orderIndex--)
   {
      if (OrderSelect(orderIndex, SELECT_BY_POS))
      {
         if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == magic))
         {
            if ((OrderType() != OP_BUY) && (OrderType() != OP_SELL))
            {
               OrderDelete(OrderTicket());
            }
            else
            {
               ClosePosBySelect();
            }
         }
      }
   }
}